/*
 * Copyright (C) 2025-2026  Tim Zimmermann <tim@aglais.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.aglais.zms.ui.tab;

import org.aglais.zms.AglaisZMS;
import org.jetbrains.annotations.NotNull;

import javax.swing.*;
import javax.swing.table.DefaultTableModel;
import java.util.ResourceBundle;

/**
 * A tab displaying various debug information
 */
public class DebugInfoTab extends Tab {
    private JPanel contentPane;
    private JTable debugInfoTable;

    /**
     * Creates a new DebugTab with the given {@link AglaisZMS} instance
     *
     * @param zms The application instance
     */
    public DebugInfoTab(AglaisZMS zms) {
        super(zms);
    }

    @Override
    public void onShow() {
        ResourceBundle uiBundle = ResourceBundle.getBundle("ui");
        DefaultTableModel debugInfoTableModel = new DefaultTableModel();
        debugInfoTable.setModel(debugInfoTableModel);
        debugInfoTableModel.addColumn(uiBundle.getString("name"));
        debugInfoTableModel.addColumn(uiBundle.getString("value"));

        debugInfoTableModel.addRow(new Object[] { "API URL", zms.getConfig().server.url() });
        debugInfoTableModel.addRow(new Object[] { "API username", zms.getConfig().server.username() });
        debugInfoTableModel.addRow(new Object[] { "API connected", zms.getClient().isConnected() });
        debugInfoTableModel.addRow(new Object[] { "API version", zms.getClient().getVersion() });
    }

    @Override
    public @NotNull JComponent getContentPane() {
        return contentPane;
    }
}
